package bfupload;

#####################################################
#BooFileUploadLibrary,v1.05 / this script is Free.  #
#bfupload.pl (C) BooBooClub 2002-2009               #
#####################################################



sub receive{
	@set = @_;

	#get_time
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
	$year = ($year + 1900);
	$mon++;
	if ($sec < 10)	{$sec = "0$sec";}
	if ($min < 10)	{$min = "0$min";}
	if ($hour < 10)	{$hour = "0$hour";}
	if ($mon < 10)	{$mon = "0$mon";}
	if ($mday < 10)	{$mday = "0$mday";}
	$time = "$year$mon$mday$hour$min$sec";

	#check_all_data_size
	if($set[0] ne '' && $ENV{'CONTENT_LENGTH'} > $set[0]){
		$errmsg = 'f[^~bglzĂ܂B';
	}

	#check_form_type
	if($ENV{'REQUEST_METHOD'} eq "POST" && $ENV{'CONTENT_TYPE'} =~ /^multipart\/form-data/){
		binmode(STDIN);
		read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	}
	else{
		$errmsg = 'tH[̐ݒɌ肪܂B';
	}

	#check_dir_permission
	if($set[2] !~ /\/$/){
		$set[2] .= '/';
	}
	if($set[2] eq '' || ! -d $set[2] || ! -w $set[2]){
		$errmsg = 'ۑfBNg̐ݒɌ肪܂B';
	}

	#get_boundary
	if($ENV{'CONTENT_TYPE'} =~ /boundary.*?=.*?(-+\w*)$/){
		$boundary = $1;
	}

	@buffer = split(/$boundary/,$buffer);
	$j = 0;
	foreach $buffer(@buffer){
		if($buffer eq '' || $buffer =~ /^-+$/ || ($errmsg ne '' && $buffer =~ /filename\s*?=\s*?"?(.*?)"?\r\n/)){
			$buffer =~ s/^-+(\r\n)//;
			$buffer =~ s/(\r\n)-+$//;
			$buffer =~ s/^(\r\n)+|(\r\n)+$//g;
			if($buffer =~ /filename\s*?=\s*?"?(.*?)"?\r\n/){
				$filename = $1;
				$buffer =~ m/ name\s*?=\s*?"(.*?)"/;
				$name = $1;
				$name =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
				$name =~ s/ /+/g;
				$formdata .= '&'.$name.'='.$filename;
			}
			next;
		}
		$buffer =~ s/^-+(\r\n)//;
		$buffer =~ s/(\r\n)-+$//;
		$buffer =~ s/^(\r\n)+|(\r\n)+$//g;
		($head,$body) = split(/\r\n\r\n/,$buffer,2);
		$head .= "\r\n";
		$head =~ m/name\s*?=\s*?"(.*?)"/;
		$fname = $name = $1;

		$name =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
		$name =~ s/ /+/g;

		if($head =~ /filename\s*?=\s*?"?(.*?)"?\r\n/){
			$file = $filename = $1;
			$file =~ m/.*[\/\\\:](.*)$/;
			$file = $1;
			if($set[4] eq '-tm'){
				$file =~ s/.*(\..*)/$time$1/;
			}
			elsif($set[4] eq '-fn'){
				$file =~ s/.*(\..*)/$fname$1/g;
			}
			$filename =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
			$filename =~ s/ /+/g;
			$formdata .= '&'.$name.'='.$filename;

			#check_each_file_size
			if($set[1] ne '' && length($body) ne '' && length($body) > $set[1]){
				$errmsg = 't@CTCY~bglzĂ܂B';
			}

			#check_file_type
			if($set[3] ne ''){
				@allow = split(/,/,$set[3]);
				$i = 0;
				foreach $allow(@allow){
					if($filename eq '' || $filename =~ /\.$allow$/){
						$i++;
					}
				}
				if($i == 0){
					$errmsg = 'Ȃt@C^CvłB';
				}
			}

			#check_filename_charactor
			if($set[4] eq '-cow' && $file ne '' && $file =~ /[^\w\.]/){
				$errmsg = 'Ȃt@CłB';
			}


			#ready_save
			push(@file,$file);
			push(@body,$body);
			$j++;
			$savefile .= '&'.$name.'='.$file;
		}
		else{
			$body =~ s/([^\.\*\-_a-zA-Z0-9 ])/sprintf("%%%02lX",unpack("C",$1))/eg;
			$body =~ s/ /+/g;
			$formdata .= '&'.$name.'='.$body;
		}
	}

	#save_file
	if($j != 0 && $errmsg eq ''){
		$i = 0;
		while($i <= $j){
			$file = $file[$i];
			$body = $body[$i];
			open (FILE,">$set[2]$file");
			binmode (FILE);
			print FILE $body;
			close (FILE);
			$i++;
		}
	}

	$formdata =~ s/^\&//;
	$savefile =~ s/^\&//;

	if($errmsg ne ''){
		$flag = 'f';
	}

	$returndata = '';
	if($set[5] eq 'get'){
		$returndata = $body[0];
	}

	return($flag,$errmsg,$formdata,$savefile,$returndata);
}

1;

